<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_ErrMessages extends Controller_Handler
{
    public function before() {
        $this->setAccessLevel(self::ACCESS_USER);
        parent::before();
    }

    public function action_getRequests() {
        $data = $this->getRequests($this->user->ID);

        $i = 0;
        $res = [];
        foreach ($data as $row) {
            $res[$i] = $row;
            ++$i;
        }

        $res['num'] = --$i;
        $this->response->body(json_encode($res));
    }

    private function getRequests($accountID) {
        $sql = "CALL `GetRequests`('0','1000','$accountID','all'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }


    public function action_createRequest() {
        $title = $_POST['title'];
        $text = $_POST['text'];
        $result = $this->sendNewRequest($this->user->ID, $title, $text);

        // todo: use twig
        $to = 'it.lab.mmcs@gmail.com';
        $subject = "Request {$result[0]['Num']}: rating system report";

        $message = "Faculty: {$this->user->FacultyName}\n";
        $message .= "Type: {$this->user->Type}\n";

        if ($this->user->Type === "teacher") {
            $message .= "Department: {$this->user['DepName']}\n";
        } elseif ($this->user->Type === 'student') {
            $message .= sprintf("Degree: %s  Grade: %s  Group: %s\n",
                $this->user['Degree'], $this->user['GradeNum'], $this->user['GroupNum']);
        }

        $message .= sprintf("Sender: %s %s %s\n\n",
            $this->user->LastName, $this->user->FirstName, $this->user->SecondName);

        $message .= "Title: " . $title . "\n";
        $message .= "Message: " . $text;

        $headers = "From: RatingSystem@no-reply.mmcs.sfedu.ru\n";
        $headers .= "Reply-To: " . $this->user['EMail'];

        $data['success'] = true;
        mail($to, $subject, $message, $headers);

        $data['success'] = ($result[0]['Num'] > 0);

        $this->response->body(json_encode($data));
    }

    private function sendNewRequest($accID, $title, $description) {
        $db = Database::instance();
        $description = $db->escape($description);
        $title = $db->escape($title);
        $sql = "SELECT `CreateRequest`('$accID', $title, $description) AS 'Num'; ";
        return DB::query(Database::SELECT, $sql)->execute();
    }
}
