<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Teacher_Discipline_Create extends Controller
{
    /** @var  User */
    private $user;

    public function before() {
        $this->user = User::instance();
        if (!$this->user->isSignedIn()) {
            $this->redirect('sign', 302);
            return;
        }
    }

    public function action_create_discipline() {
        $twig = Twig::factory('teacher/discipline/create');

        $twig->User = $this->user;
        $twig->FacultiesList = Model_Faculties::load();
        $twig->SubjectsList = Model_Faculty::with($this->user->FacultyID)->getSubjects();
        $twig->GradesList = Model_Grades::toArray();

        $this->response->body($twig);
    }

    # todo: move to Coursework folder
    public function action_create_coursework() {
        $twig = Twig::factory('teacher/coursework/create');

        $twig->User = $this->user;
        $twig->FacultiesList = Model_Faculties::load();
        $twig->SubjectsList = Model_Faculty::with($this->user->FacultyID)->getSubjects();
        $twig->GradesList = Model_Grades::toArray();

        $this->response->body($twig);
    }
}
            